<?php
// 記事内の画像を取ってくる
function get_the_content_image($no=0) {
	global $post;
	return _get_the_content_image($post, $no);
}
// 記事ID指定
function get_the_content_image_by_postID($postid, $no=0) {
	$post = get_post($postid);
	return _get_the_content_image($post, $no);
}

function _get_the_content_image($post, $no=0)
{
	// 子テーマのimagesに画像がなかったときのイメージnoimage.pngを作っておく
	$noImage = get_stylesheet_directory_uri().'/images/noimage.png';
	// <img　で始まる部分を探す
	$output = preg_match_all('/<img.+src=[\'"]([^\'"]+)[\'"].*>/i', $post->post_content, $matches);
	if($output > $no){
		$first_img = $matches [1] [$no];
	} else {
		if($no > 0){
			if($output > 0){
				$first_img = $matches [1] [0];
			} else {
				$first_img = $noImage;
			}
		} else {
			$first_img = $noImage;
		}
	}
	return $first_img;
}

// graviatarのアイコンを投稿ページに表示する修正
// inc/template-tags.php　の twentyfourteen_posted_on　を先に定義する
function twentyfourteen_posted_on() {
	// 開始　graviatarアバターを表示する 追加
	// アバターの縦サイズを指定
	$avatarHeight = 50;
	echo '<div style="float:left;margin-bottom:5px;margin-right:5px;">'.get_avatar( get_the_author_meta('email'), $avatarHeight )."</div>"; 
	// 終了　graviatarアバターを表示する 追加
	
	if ( is_sticky() && is_home() && ! is_paged() ) {
		echo '<span class="featured-post">' . __( 'Sticky', 'twentyfourteen' ) . '</span>';
	}
	// Set up and print post meta information.
	printf( '<span class="entry-date"><a href="%1$s" rel="bookmark"><time class="entry-date" datetime="%2$s">%3$s</time></a></span> <span class="byline"><span class="author vcard"><a class="url fn n" href="%4$s" rel="author">%5$s</a></span></span>',
		esc_url( get_permalink() ),
		esc_attr( get_the_date( 'c' ) ),
		esc_html( get_the_date() ),
		esc_url( get_author_posts_url( get_the_author_meta( 'ID' ) ) ),
		get_the_author()
	);
}
// h2にfontawesomeを追加する
function ryus_h2_add($text ) {
	$text = str_replace('<h2>', '<h2><i class="fa fa-smile-o" style="font-size:24px;margin-right:5px;"></i>', $text);
	return $text;
}
// blockquoteにfontawesomeで“”を追加する
function ryus_blockquote_add($text) {
	$text = str_replace('<blockquote>', '<blockquote><div style="width:100%;text-align:left;"><i class="fa  fa-quote-left" style="font-size:24px;"></i></div>', $text);
	$text = str_replace('</blockquote>', '<div style="width:100%;position:relative;margin-top:-24px;text-align:right;"><i class="fa  fa-quote-right" style="font-size:24px;"></i></div></blockquote>', $text);
	return $text;
}

// 共有が表示されていたら最後にはてブを追加する
function ryus_share_hatebu_add($text) {
	$text = str_replace('<li class="share-end"></li>', '<li><a href="http://b.hatena.ne.jp/entry/<?php the_permalink(); ?>" class="hatena-bookmark-button" data-hatena-bookmark-title="<?php the_title(); ?>" data-hatena-bookmark-layout="standard-balloon" data-hatena-bookmark-lang="ja" title="このエントリーをはてなブックマークに追加"><img src="http://b.st-hatena.com/images/entry-button/button-only@2x.png" alt="このエントリーをはてなブックマークに追加" width="20" height="20" style="border: none;" /></a><script type="text/javascript" src="http://b.st-hatena.com/js/bookmark_button.js" charset="utf-8" async="async"></script>
</li><li class="share-end"></li>', $text);
	return $text;
}


// blockquoteに文字でで“”を追加する
function ryus_blockquote_moji_add($text) {
	$text = str_replace('<blockquote>', '<blockquote><div style="width:100%;text-align:left;font-size:30px;font-weight:bold;line-height:1em;">“</div>', $text);
	$text = str_replace('</blockquote>', '<div style="width:100%;position:relative;margin-top:-24px;text-align:right;font-size:30px;font-weight:bold;line-height:1em;">”</div></blockquote>', $text);
	return $text;
}

/* ここにショートコードの関数を書く */
function ryus_phpinfo() {
	global $current_user;
	get_currentuserinfo();
	if(is_user_logged_in()){
		if ($current_user->user_level == 10) {
			return phpinfo();
		}
	}
}
/* ショートコードを追加する */
add_shortcode('ryus_phpinfo', 'ryus_phpinfo');

function ryus_is_user_logged_in() {
	//return ;
	return " this is_user_logged_in=".is_user_logged_in();
}
add_shortcode('ryus_is_user_logged_in', 'ryus_is_user_logged_in');

add_filter( 'the_content', 'ryus_h2_add' );
add_filter( 'the_content', 'ryus_blockquote_add' );

function publish_confirm_admin_print_scripts() {
	echo <<< EOM
<script type="text/javascript">
<!--
window.onload = function() {
	var id = document.getElementById('publish');
	if (id.value.indexOf("公開", 0) != -1) {
		id.onclick = publish_confirm;
	}
}
function publish_confirm() {
	answer = window.prompt("ほんとに、ほんとに公開？大丈夫？", "");
	if (answer == '大丈夫') {
		return true;
	} else {
		var elements = document.getElementsByTagName('span');
		for (var i = 0; i < elements.length; i++) {
			var element = elements[i];
			if (element.className.indexOf("spinner", 0) != -1) {
				element.classList.remove('spinner');
			}
		}
		document.getElementById('publish').classList.remove('button-primary-disabled');
		document.getElementById('save-post').classList.remove('button-disabled');

			return false;
	}
}
// -->
</script>
EOM;
}

// 公開する前にアラートを表示する
add_action('admin_print_scripts', 'publish_confirm_admin_print_scripts');

// jetpackのパブリサイズ共有で自動的に出力されるOGPを削除
add_filter('jetpack_enable_open_graph', '__return_false', 99);

date_default_timezone_set('Asia/Tokyo');

function add_query_vars_filter( $vars ){
  $vars[] = "home_option";
  return $vars;
}
add_filter( 'query_vars', 'add_query_vars_filter' );

/* 投稿記事に別の投稿へのリンクを表示する */
function ryus_another_post_link($atts) {
	$home = home_url('/');
	$linkString = '<a href="'. $home. '%s/" target="_blank">%s</a>'; // 表示したいリンクのひな形。サイトによって異なるので適宜変更する(targetとか)
	/* 引数を展開する */
	extract(
		shortcode_atts(
			array(
				'id' => ''
			),
			$atts
		)
	);
	if($id != ''){
		// idから投稿情報を取得
		$anotherPost = get_post($id);
		if (is_object($anotherPost)){
			return sprintf($linkString, $anotherPost->post_name, $anotherPost->post_title);
		}
	}
	return $id;
}

/* 与えられた日付に曜日と祝日名を追加して返すショートコード */
function ryus_day_dayedit($atts){
	// day は　yyyy-mm-dd の形で指定されている
	/* 引数を展開する */
	extract(
		shortcode_atts(
			array(
				'day' => ''
			),
			$atts
		)
	);
	if($day == ''){
		$day = date("Y-m-d", strtotime('today'));
	}
	return _ryus_day_dayedit($day);
}

function _ryus_day_dayedit($day, $dayborder=''){
	// dayで渡された日付に曜日と祝日であればその内容を追加して返す
	$youbi = _waYoubi(date('w', strtotime($day)));
	$shukujitsu = _getShukujitsu($day);
	// html。必要に応じて適宜変更する
	if ($dayborder == ''){
		$dayHtml = '<div style="width:100%;border:dotted 1px #333;padding:5px;margin-bottom:5px;">'.$day.'('.$youbi.') '.$shukujitsu.'</div>';
	} else {
		$dayHtml = '<div>'.$day.'('.$youbi.') '.$shukujitsu.'</div>';
	}
	return $dayHtml;
}
add_shortcode( 'ryus_day_dayedit', 'ryus_day_dayedit' );

function _waYoubi($w){
	$waYoubi = array('日', '月', '火', '水', '木', '金', '土');
	return $waYoubi[$w];
}

function _getShukujitsu($day){
	// 日本の祝日feed
	$feed = 'https://www.google.com/calendar/feeds/ja.japanese%23holiday%40group.v.calendar.google.com/public/basic';
	$start = urlencode(date(DATE_ATOM, strtotime($day.' 00:00:00 +9 hour')));
	$end = urlencode(date(DATE_ATOM, strtotime($day.' 23:59:59  +9 hour')));
	$addParam = '?start-min='.$start.'&start-max='.$end;
	$xml = simplexml_load_file($feed.$addParam);
	if(isset($xml->entry)){
			return $xml->entry[0]->title;
	}
	return '';
}

/* Googleカレンダーから指定された日の予定を表示する */
function ryus_google_calendar_day($atts) {
	/* 引数を展開する */
	extract(
		shortcode_atts(
			array(
				'feed' => '',
				'day' => '',
				'plus' => '',
				'title' => '',
				'time' => '',
				'place' => '',
				'description' => '',
				'dayborder' => '',
			),
			$atts
		)
	);

	$feedString = '';
	if($day == ''){
		$day = date("Y-m-d", strtotime('today'));
	}
	if($plus != ''){
		$day = date("Y-m-d", strtotime($day.' +'.$plus.' day'));
	}
	$start = urlencode(date(DATE_ATOM, strtotime($day.' 00:00:00 +9 hour')));
	$end = urlencode(date(DATE_ATOM, strtotime($day.' 23:59:59  +9 hour')));

	$feedString = _ryus_day_dayedit($day, $dayborder);
	// singleevents=true にしないと繰り返し予定が他の予定と同じ形で取得できない
	$addParam = '?start-min='.$start.'&start-max='.$end.'&singleevents=true&orderby=starttime';

	$xml = simplexml_load_file($feed.$addParam);

	$entries = array(); // key=no
	$count = 0;
	$sortArray = array();
	
	foreach($xml->entry as $key=>$entry){
		$contents = explode("<br />", $entry->content[0]);
		$content = array();
		foreach ($contents as $val){
			if($val != ''){
				if (mb_substr($val, 0, 2) == '期間'){
					// 期間は　:　が複数あるので別処理
					$val = str_replace('期間:', '期間@', $val);
					$valExplode = explode('@', $val);
					// 期間の内容から日付とJSTを削除する
					$kikanTemp = explode(')', $valExplode[1]);
					$valExplode[1] = str_replace('JST', '', $kikanTemp[1]);
				} else {
					$valExplode = explode(':', $val);
				}
				if(count($valExplode) == 2){
					$valKey = $valExplode[0];
					if(strlen($valKey) > 0){
						$content[$valKey] = $valExplode[1];
					}
				}
			}
		}
		$title = (array)$entry->title;
		$content['title'] = $title[0];
		$entries[$count] = $content;
		if(isset($content['期間'])){
			$sortArray[$count] = $content['期間'];
		} else {
			// 終日予定を上に
			$sortArray[$count] = '';
		}
		$count++;
	}
	asort($sortArray);
	$feedString .= _entryEdit($entries, $sortArray, $title, $time, $place, $description );
	return $feedString;

}

function _entryEdit($entries, $sortArray, $title='', $time='', $place='', $description='') {
	// Googleカレンダーより取得したentryを編集する
	// htmlを変更したいときはここを適宜変更
	$entryEdit = '';
	if(count($entries) < 1){
		return '本日の予定はありません。';
	}
	foreach($sortArray as $key=>$val){
		$entry = $entries[$key];
		if($title == ''){
			// タイトル
			$entryEdit .= '<div style="font-weight:bold;">'.$entry['title'].'</div>';
			$entryEdit .= '<ul style="padding:5px;margin:10px;border-bottom:dotted 1px #333;">';
		}
		if($time == ''){
			// 期間 or 開始日　終日の時は開始日
			if(isset($entry['期間'])){
				$entryEdit .= '<li>時間：'.$entry['期間'].'</li>';
			} else {
				$entryEdit .= '<li>時間：終日'.'</li>';
			}
		}
		if($place == ''){
			// 場所
			if(isset($entry['場所'])){
				$entryEdit .= '<li>場所：'.$entry['場所'].'</li>';
			}
		}
		if($description == ''){
			// 説明
			if(isset($entry['予定の説明'])){
				$entryEdit .= '<li>説明：<div style="margin-left:10px;">'.nl2br($entry['予定の説明']).'</div></li>';
			}
		}
		$entryEdit .= '</ul>';
	}	
	return $entryEdit;
}
add_shortcode( 'ryus_google_calendar_day', 'ryus_google_calendar_day' );

// メニューバーにカスタムメニューを追加する
function mytheme_admin_bar_render() {
	global $wp_admin_bar;
		$wp_admin_bar->add_menu( array(
			'id' => 'postlist',
			'title' => 'ショートカット(^^)/',
			'href' => admin_url( 'edit.php')
		));
		$wp_admin_bar->add_menu( array(
			'parent' => 'postlist',
			'id' => 'edit',
			'title' => '投稿一覧',
			'href' => admin_url( 'edit.php')
		));
		
		$wp_admin_bar->add_menu( array(
			'parent' => 'postlist',
			'id' => 'edit_draft',
			'title' => '投稿下書き一覧',
			'href' => admin_url( 'edit.php?post_status=draft&post_type=post')
		));
		
		$wp_admin_bar->add_menu( array(
			'parent' => 'postlist',
			'id' => 'page',
			'title' => '固定ページ一覧',
			'href' => admin_url( 'post-new.php?post_type=page')
		));
		
		$wp_admin_bar->add_menu( array(
			'parent' => 'postlist',
			'id' => 'page-new',
			'title' => '新規固定ページ',
			'meta'   => array(
						'target' => '_blank',
					),
			'href' => admin_url( 'post-new.php?post_type=page')
		));

}

add_action( 'wp_before_admin_bar_render', 'mytheme_admin_bar_render' );

// 別の記事が公開されていたら表示する
/* 予約投稿とかの時、公開済み記事に「補足でこういうblog書きました」みたいに表示したいけど、予約なので投稿されるまでは見せたくない。といって公開されるまで待つと書き忘れる、という教訓から */
function ryus_show_when_published ( $atts, $content = null ) {
	extract( shortcode_atts( array(
		'postid' => '',
		'slug' => '',
	), $atts ) );
	// スラッグ指定の時、postidを取得する
	if($slug != ''){
		$postid = url_to_postid(site_url().'/'.$slug);
	}
	if($postid != ''){
		$post = get_post($postid);
		if($post){
			if($post->post_status == 'publish'){
				return $content;
			}
		}
	}
	return '';
}

add_shortcode('ryus_show_when_published', 'ryus_show_when_published');

// ダッシュボード投稿一覧にpostIDを追加する
function add_posts_columns_postid($columns) {
	$columns['postid'] = 'ID';
	return $columns;
}
function add_posts_columns_postid_row($column_name, $post_id) {
	if( $column_name == 'postid' ) {
		echo $post_id;
	}
}
add_filter( 'manage_posts_columns', 'add_posts_columns_postid' );
add_action( 'manage_posts_custom_column', 'add_posts_columns_postid_row', 10, 2 );

// ダッシュボード投稿一覧にスラッグを追加する
function add_posts_columns_post_name($columns) {
	$columns['post_name'] = 'スラッグ';
	return $columns;
}
function add_posts_columns_post_name_row($column_name, $post_id) {
	if( $column_name == 'post_name' ) {
		$post = get_post($post_id);
		echo $post->post_name;
	}
}
add_filter( 'manage_posts_columns', 'add_posts_columns_post_name' );
add_action( 'manage_posts_custom_column', 'add_posts_columns_post_name_row', 10, 2 );

// refs.http://webpaprika.com/347.html
// function.php
class relative_URI {
    function relative_URI() {
        add_action('get_header', array(&$this, 'get_header'), 1);
        add_action('wp_footer', array(&$this, 'wp_footer'), 99999);
    }
    function replace_relative_URI($content) {
        $home_url = trailingslashit(get_home_url('/'));
        return str_replace($home_url, 'http://192.168.5.110/ryuswp/', $content);
    }
    function get_header(){
        ob_start(array(&$this, 'replace_relative_URI'));
    }
    function wp_footer(){
        ob_end_flush();
    }
}
if (is_apple()) {
    new relative_URI();
}
function is_apple() {
    $useragents = array(
        'iPhone',           // Apple iPhone
        'iPod',             // Apple iPod touch
        'incognito',        // Other iPhone browser
        'webmate'           // Other iPhone browser
    );
    $pattern = '/'.implode('|', $useragents).'/i';
    return preg_match($pattern, $_SERVER['HTTP_USER_AGENT']);
}

add_filter('widget_text', 'do_shortcode');